# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTIBILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.

bl_info = {
    "name" : "Water Droplets Generator ",
    "author" : "CGBlender", 
    "description" : "Water Droplets Generator ",
    "blender" : (3, 5, 0),
    "version" : (1, 0, 0),
    "location" : "",
    "warning" : "",
    "doc_url": "", 
    "tracker_url": "", 
    "category" : "3D View" 
}


import bpy
import bpy.utils.previews
import os


addon_keymaps = {}
_icons = None
_item_map = dict()


def make_enum_item(_id, name, descr, preview_id, uid):
    lookup = str(_id)+"\0"+str(name)+"\0"+str(descr)+"\0"+str(preview_id)+"\0"+str(uid)
    if not lookup in _item_map:
        _item_map[lookup] = (_id, name, descr, preview_id, uid)
    return _item_map[lookup]


def load_preview_icon(path):
    global _icons
    if not path in _icons:
        if os.path.exists(path):
            _icons.load(path, path, "IMAGE")
        else:
            return 0
    return _icons[path].icon_id


def sna_update_sna_water_droplets_generator__8A609(self, context):
    sna_updated_prop = self.sna_water_droplets_generator_
    before_data = list(bpy.data.node_groups)
    bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', '3D-CAN-MODEL.blend') + r'\NodeTree', filename=sna_updated_prop, link=False)
    new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
    appended_B941D = None if not new_data else new_data[0]
    modifier_7EE75 = bpy.context.active_object.modifiers.new(name=sna_updated_prop, type='NODES', )
    bpy.context.active_object.modifiers.active.node_group = bpy.data.node_groups[sna_updated_prop]
    for i_95C67 in range(len(bpy.context.view_layer.objects.selected)):
        if bpy.context.view_layer.objects.selected[i_95C67].select_get():
            bpy.context.view_layer.objects.active = bpy.context.view_layer.objects.selected[i_95C67]


class SNA_PT_WATER_DROPLETS_GENERATOR__4F89D(bpy.types.Panel):
    bl_label = 'Water Droplets Generator '
    bl_idname = 'SNA_PT_WATER_DROPLETS_GENERATOR__4F89D'
    bl_space_type = 'VIEW_3D'
    bl_region_type = 'UI'
    bl_context = ''
    bl_category = 'WD'
    bl_order = 0
    bl_ui_units_x=0

    @classmethod
    def poll(cls, context):
        return not (False)

    def draw_header(self, context):
        layout = self.layout

    def draw(self, context):
        layout = self.layout
        layout.template_icon_view(bpy.context.scene, 'sna_water_droplets_generator_', show_labels=False, scale=5.0, scale_popup=5.0)
        attr_537FC = '["' + str('Socket_16_attribute_name' + '"]') 
        layout.prop(bpy.context.view_layer.objects.active.modifiers['WATER DROPLETS Generator2'], attr_537FC, text='Selection', icon_value=0, emboss=True)
        attr_94399 = '["' + str('Socket_10' + '"]') 
        layout.prop(bpy.context.view_layer.objects.active.modifiers['WATER DROPLETS Generator2'], attr_94399, text='DB1 Density', icon_value=0, emboss=False)
        attr_89D30 = '["' + str('Socket_11' + '"]') 
        layout.prop(bpy.context.view_layer.objects.active.modifiers['WATER DROPLETS Generator2'], attr_89D30, text='DB2 Density', icon_value=0, emboss=False)
        layout.prop(bpy.data.node_groups['WATER DROPLETS Generator2'].nodes['Set Material.001'].inputs[2], 'default_value', text='Object Material', icon_value=0, emboss=True)
        layout.prop(bpy.data.node_groups['WATER DROPLETS Generator2'].nodes['Set Material'].inputs[2], 'default_value', text='Water Material', icon_value=0, emboss=True)
        attr_84FE8 = '["' + str('Socket_17' + '"]') 
        layout.prop(bpy.context.view_layer.objects.active.modifiers['WATER DROPLETS Generator2'], attr_84FE8, text='Seed', icon_value=0, emboss=False)
        attr_DA1E5 = '["' + str('Socket_14' + '"]') 
        layout.prop(bpy.context.view_layer.objects.active.modifiers['WATER DROPLETS Generator2'], attr_DA1E5, text='DB1 Scale', icon_value=0, emboss=False)
        attr_E12A9 = '["' + str('Socket_15' + '"]') 
        layout.prop(bpy.context.view_layer.objects.active.modifiers['WATER DROPLETS Generator2'], attr_E12A9, text='DB2 Scale', icon_value=0, emboss=False)


def sna_water_droplets_generator__enum_items(self, context):
    enum_items = [['WATER DROPLETS Generator2', 'WATER DROPLETS Generator2', '', load_preview_icon(os.path.join(os.path.dirname(__file__), 'assets', 'dricon.png'))]]
    return [make_enum_item(item[0], item[1], item[2], item[3], i) for i, item in enumerate(enum_items)]


def register():
    global _icons
    _icons = bpy.utils.previews.new()
    bpy.types.Scene.sna_water_droplets_generator_ = bpy.props.EnumProperty(name='Water Droplets Generator ', description='', items=sna_water_droplets_generator__enum_items, update=sna_update_sna_water_droplets_generator__8A609)
    bpy.utils.register_class(SNA_PT_WATER_DROPLETS_GENERATOR__4F89D)


def unregister():
    global _icons
    bpy.utils.previews.remove(_icons)
    wm = bpy.context.window_manager
    kc = wm.keyconfigs.addon
    for km, kmi in addon_keymaps.values():
        km.keymap_items.remove(kmi)
    addon_keymaps.clear()
    del bpy.types.Scene.sna_water_droplets_generator_
    bpy.utils.unregister_class(SNA_PT_WATER_DROPLETS_GENERATOR__4F89D)
